/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.registry;

import net.smartlab.web.BusinessObject;

/**
 * Represents a fully qualified description of a city or town.
 * 
 * @author rlogiacco
 * @stereotype component
 */
public class Locality extends BusinessObject {

	private final static long serialVersionUID = 8382450593023598729L;

	/**
	 * The country.
	 */
	private Country country = Country.UNDEFINED;
	/**
	 * The state name.
	 */
	private String state;
	/**
	 * The city name.
	 */
	private String city;

	/**
	 * Returns the city name.
	 * 
	 * @hibernate.property column="`city`" length="100"
	 * @return returns the city name.
	 */
	public String getCity() {
		return city;
	}

	/**
	 * Sets the city name.
	 * 
	 * @param city the city name to set.
	 */
	public void setCity(String city) {
		this.city = city;
	}

	/**
	 * Returns the country name.
	 * 
	 * @hibernate.property column="`country`" length="2"
	 * @return returns the country name.
	 */
	public Country getCountry() {
		return country;
	}

	/**
	 * Sets the country name.
	 * 
	 * @param country the country name to set.
	 */
	public void setCountry(Country country) {
		this.country = country;
	}

	/**
	 * Returns the state name.
	 * 
	 * @hibernate.property column="`state`" length="150"
	 * @return returns the state name.
	 */
	public String getState() {
		return state;
	}

	/**
	 * Sets the state name.
	 * 
	 * @param state the state name to set.
	 */
	public void setState(String state) {
		this.state = state;
	}
}