/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.registry;

import net.smartlab.web.Enumeration;

/**
 * TODO documentation
 * @author rlogiacco
 * @hibernate.joined-subclass schema="registry" table="`messenger-address`"
 * @hibernate.joined-subclass-key column="`id`"
 */
public class MessengerAddress extends Address {

	private final static long serialVersionUID = 5917703384188478000L;

	/**
	 * TODO documentation
	 */
	private final static Protocol[] PROTOCOL_LIST = new Protocol[] {
			Protocol.YAHOO, 
			Protocol.MSN, 
			Protocol.ICQ, 
			Protocol.AOL, 
			Protocol.JABBER};

	/**
	 * TODO documentation
	 */
	private Protocol protocol;

	/**
	 * TODO documentation
	 */
	private String uid;

	/**
	 * TODO documentation
	 * @hibernate.property column="`uid`" length="100"
	 * @return returns the uid.
	 */
	public String getUid() {
		return uid;
	}

	/**
	 * TODO documentation
	 * @param uid the uid to set.
	 */
	public void setUid(String uid) {
		this.uid = uid;
	}

	/**
	 * TODO documentation
	 * @return returns the <code>protocol</code>.
	 * @hibernate.property column="`protocol`"
	 *                     type="net.smartlab.web.registry.MessengerAddress$Protocol"
	 */
	public Protocol getProtocol() {
		return protocol;
	}

	/**
	 * TODO documentation
	 * @return
	 */
	public Protocol[] getProtocols() {
		return PROTOCOL_LIST;
	}

	/**
	 * TODO documentation
	 * @param protocol the <code>protocol</code> to set.
	 */
	public void setProtocol(Protocol protocol) {
		this.protocol = protocol;
	}
    

    /**
     * @see net.smartlab.web.registry.Address#getFormattedString()
     */
    public String getFormattedString() {
        return protocol + ":" + uid;
    }

	/**
	 * TODO documentation
	 * @author rlogiacco
	 */
	public static class Protocol extends Enumeration {

		private static final long serialVersionUID = 8233518844869946720L;

		/**
		 * TODO documentation
		 */
		public final static Protocol YAHOO = new Protocol('Y', "server.yahoo");
		/**
		 * TODO documentation
		 */
		public final static Protocol MSN = new Protocol('M', "server.msn");
		/**
		 * TODO documentation
		 */
		public final static Protocol ICQ = new Protocol('I', "server.icq");
		/**
		 * TODO documentation
		 */
		public final static Protocol AOL = new Protocol('A', "server.aol");
		/**
		 * TODO documentation
		 */
		public final static Protocol JABBER = new Protocol('J', "server.jabber");

		/**
		 * TODO documentation
		 */
		public Protocol() {
			super();
		}

		/**
		 * TODO documentation
		 * @param id
		 * @param display
		 */
		private Protocol(int id, String display) {
			super(id, display);
		}

		/**
		 * @see net.smartlab.web.Enumeration#decode(int)
		 */
		public Enumeration decode(int id) {
			switch (id) {
				case 'Y':
					return YAHOO;
				case 'M':
					return MSN;
				case 'I':
					return ICQ;
				case 'A':
					return AOL;
				case 'J':
					return JABBER;
				default:
					return JABBER;
			}
		}
	}
}