/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.registry;

import net.smartlab.web.Enumeration;

/**
 * TODO documentation
 * @author rlogiacco
 * @hibernate.joined-subclass schema="registry" table="`phone-address`"
 * @hibernate.joined-subclass-key column="`id`"
 */
public class PhoneAddress extends Address {

	private final static long serialVersionUID = 3869122455081575457L;

	/**
	 * TODO documentation
	 */
	public final static Type[] TYPE_LIST = new Type[] {
			Type.MOBILE, 
			Type.HOME, 
			Type.OFFICE, 
			Type.PAGER, 
			Type.FAX};

	/**
	 * @directed true
	 */
	private MailAddress location;

	private String number;

	private Type type;

	/**
	 * TODO documentation
	 * @return Returns the address.
	 * @hibernate.many-to-one column="`location`"
	 */
	public MailAddress getLocation() {
		return location;
	}

	/**
	 * TODO documentation
	 * @param location The address to set.
	 */
	public void setLocation(MailAddress location) {
		this.location = location;
	}

	/**
	 * TODO documentation
	 * @hibernate.property column="`number`" length="20"
	 * @return Returns the number.
	 */
	public String getNumber() {
		return number;
	}

	/**
	 * TODO documentation
	 * @param number The number to set.
	 */
	public void setNumber(String number) {
		this.number = number;
	}

	/**
	 * TODO documentation
	 * @hibernate.property column="`type`"
	 *                     type="net.smartlab.web.registry.PhoneAddress$Type"
	 * @return Returns the type.
	 */
	public Type getType() {
		return type;
	}

	/**
	 * TODO documentation
	 * @return
	 */
	public Type[] getTypes() {
		return TYPE_LIST;
	}

	/**
	 * TODO documentation
	 * @param type The type to set.
	 */
	public void setType(Type type) {
		this.type = type;
	}
    
    /**
     * @see net.smartlab.web.registry.Address#getFormattedString()
     */
    public String getFormattedString(){
        return this.number;
    }

	/**
	 * TODO documentation
	 * @author rlogiacco
	 */
	public static class Type extends Enumeration {

		private static final long serialVersionUID = -5554496741521318547L;
		
		/**
		 * TODO documentation
		 */
		public final static Type MOBILE = new Type('M', "phone.mobile");
		
		/**
		 * TODO documentation
		 */
		public final static Type HOME = new Type('H', "phone.home");
		
		/**
		 * TODO documentation
		 */
		public final static Type OFFICE = new Type('O', "phone.office");
		
		/**
		 * TODO documentation
		 */
		public final static Type PAGER = new Type('P', "phone.pager");
		
		/**
		 * TODO documentation
		 */
		public final static Type FAX = new Type('F', "phone.fax");

		/**
		 * TODO documentation
		 */
		public Type() {
			super();
		}

		/**
		 * TODO documentation
		 * @param id
		 * @param display
		 */
		private Type(int id, String display) {
			super(id, display);
		}

		/**
		 * @see net.smartlab.web.Enumeration#decode(int)
		 */
		public Enumeration decode(int id) {
			switch (id) {
				case 'M':
					return MOBILE;
				case 'H':
					return HOME;
				case 'O':
					return OFFICE;
				case 'P':
					return PAGER;
				case 'F':
					return FAX;
				default:
					return null;
			}
		}
	}
}