/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.registry;

import java.net.MalformedURLException;
import java.net.URL;

/**
 * Represents a fully qualified URL.
 * 
 * @author rlogiacco
 * @hibernate.joined-subclass schema="registry" table="`web-address`"
 * @hibernate.joined-subclass-key column="`id`"
 */
public class WebAddress extends Address {

	private final static long serialVersionUID = -419769087017551138L;

	/**
	 * TODO documentation
	 */
	private String url;

	/**
	 * TODO documentation
	 * 
	 * @hibernate.property column="`url`" length="200"
	 * @return returns the email.
	 */
    protected String getUrl() {
        return url;
    }
    
    /**
     * TODO documentation
     * @param url
     */
    protected void setUrl(String url) {
        this.url = url;
    }
    
	/**
	 * TODO documentation
	 * @return
	 */
	public URL getURL() {
		try {
            return new URL(url);
        } catch (MalformedURLException murle) {
            logger.error("getURL() - failed", murle);
            return null;
        }
	}
        
    /**
     * TODO documentation
     * @param url
     */
    public void setURL(URL url) {
        this.url = url.toString();
    }
    
    /**
     * @see net.smartlab.web.registry.Address#getFormattedString()
     */
    public String getFormattedString(){
        return url;
    }
}